import { createElement } from "react";
/**
 * QuillForms Dependencies
 */
import { BaseControl, ControlWrapper, ControlLabel, ChoicesBulkBtn, ChoicesInserter } from '@quillforms/admin-components';

/**
 * WordPress Dependecies
 */
import { Fragment } from 'react';
const DropdownControls = props => {
  const {
    attributes: {
      choices
    },
    setAttributes
  } = props;
  return createElement(Fragment, null, createElement(BaseControl, null, createElement(ControlWrapper, {
    orientation: "horizontal"
  }, createElement(ControlLabel, {
    label: "Choices"
  }), createElement(ChoicesBulkBtn, {
    choices: choices,
    setChoices: val => {
      setAttributes({
        choices: val
      });
    }
  })), createElement(ControlWrapper, {
    orientation: "vertical"
  }, createElement(ChoicesInserter, {
    choices: choices,
    setChoices: val => {
      setAttributes({
        choices: val
      });
    }
  }))));
};
export default DropdownControls;
//# sourceMappingURL=controls.js.map